define(["require", "exports", "tslib", "react", "./KeytipSetup", "office-ui-fabric-react/lib/Checkbox", "office-ui-fabric-react/lib/ComboBox", "office-ui-fabric-react/lib/Dropdown", "office-ui-fabric-react/lib/Link", "office-ui-fabric-react/lib/SpinButton", "office-ui-fabric-react/lib/Toggle", "office-ui-fabric-react/lib/Pivot"], function (require, exports, tslib_1, React, KeytipSetup_1, Checkbox_1, ComboBox_1, Dropdown_1, Link_1, SpinButton_1, Toggle_1, Pivot_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var KeytipsBasicExample = /** @class */ (function (_super) {
        tslib_1.__extends(KeytipsBasicExample, _super);
        function KeytipsBasicExample() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._sampleOptions = [
                { key: 'A', text: 'Option 1' },
                { key: 'B', text: 'Option 2' },
                { key: 'C', text: 'Option 3' }
            ];
            return _this;
        }
        /* tslint:disable:jsx-ban-props jsx-no-lambda */
        KeytipsBasicExample.prototype.render = function () {
            return (React.createElement("div", null,
                React.createElement(Pivot_1.Pivot, null,
                    React.createElement(Pivot_1.PivotItem, { linkText: "Pivot 1", keytipProps: KeytipSetup_1.keytipMap.Pivot1Keytip, style: { height: 150, width: 500 } },
                        React.createElement(SpinButton_1.SpinButton, { label: 'Spin Button', keytipProps: KeytipSetup_1.keytipMap.SpinButtonKeytip }),
                        React.createElement(Toggle_1.Toggle, { keytipProps: KeytipSetup_1.keytipMap.ToggleKeytip, onText: 'Yes', offText: 'No' }),
                        React.createElement("p", null,
                            "Go to",
                            ' ',
                            React.createElement(Link_1.Link, { keytipProps: KeytipSetup_1.keytipMap.LinkKeytip, href: 'http://www.bing.com', target: "_blank" }, "Bing"))),
                    React.createElement(Pivot_1.PivotItem, { linkText: "Pivot 2", keytipProps: KeytipSetup_1.keytipMap.Pivot2Keytip, style: { height: 150, width: 500 } },
                        React.createElement(Checkbox_1.Checkbox, { keytipProps: KeytipSetup_1.keytipMap.CheckboxKeytip, label: 'Checkbox' }),
                        React.createElement(Dropdown_1.Dropdown, { label: 'Dropdown', keytipProps: KeytipSetup_1.keytipMap.DropdownKeytip, options: this._sampleOptions })),
                    React.createElement(Pivot_1.PivotItem, { linkText: "Pivot 3", keytipProps: KeytipSetup_1.keytipMap.Pivot3Keytip, style: { height: 150, width: 500 } },
                        React.createElement(ComboBox_1.ComboBox, { label: 'Combo Box', options: this._sampleOptions, keytipProps: KeytipSetup_1.keytipMap.ComboBoxKeytip })))));
        };
        return KeytipsBasicExample;
    }(React.Component));
    exports.KeytipsBasicExample = KeytipsBasicExample;
});
//# sourceMappingURL=Keytips.Basic.Example.js.map